// row operations effect on matrix multiplications

clc
clear

// defining matrix
A = [1,-2,1; 3,4,2];
B = [3,7; 0,-1; 5,2];

disp('A =', A, 'B =', B);

// finding AB -> (multiplication of both matrix)
AB = A*B;

// performing row operation on AB -> R(AB)
// row2 ← −2*row1 + row2
AB(2,:) = -2*AB(1,:) + AB(2,:);
disp('R(AB)', AB);

// performaing row operation on A and multiplying with B -> R(A)B
A(2,:) = -2*A(1,:) + A(2,:);
AB = A*B;
disp('R(A)B', AB)

// new row operations
// R1: row1 ↔ row2
// R2: row1 ← −3*row2 + row1
// R3: row1 ← 4*row1

// redefining A and B matrix to original -> given in question
A = [1,-2,1; 3,4,2];
B = [3,7; 0,-1; 5,2];

// performing row operation R3(R2(R1(AB))) on AB
AB = A*B; // finding AB -> (multiplication of both matrix)

// performing R1 on AB
temp = AB(1,:);
AB(1,:) = AB(2,:);
AB(2,:) = temp;

// performing R2 on R1(AB)
AB(1,:) = -3*AB(2,:) + AB(1,:);

// performing R3 on R2(R1(AB))
AB(1,:) = 4*AB(1,:);

disp('R3(R2(R1(AB)))', AB);


// redefining A and B matrix to original -> given in question
A = [1,-2,1; 3,4,2];
B = [3,7; 0,-1; 5,2];

// performing row operation R3(R2(R1(A))) on A and multiplying with B -> R3(R2(R1(A)))B

// performing R1 on A
temp = A(1,:);
A(1,:) = A(2,:);
A(2,:) = temp;

// performing R2 on R1(A)
A(1,:) = -3*A(2,:) + A(1,:);

// performing R3 on R2(R1(A))
A(1,:) = 4*A(1,:);

// multiplying R3(R2(R1(A))) with B
AB = A*B;

disp('R3(R2(R1(A)))B', AB);
