// Diagonalization

clc
clear

A=[-4,7,1,4; 6,-16,-3,-9; 12,-27,-4,-15; -18,43,7,24];
disp('A=', A);

// eigen values
eigen_value = unique(round(spec(A)));
disp('Eigen values are ', eigen_value);

// finding eigen vector
[eigen_vector eigen_value] = spec(A);

disp('corresponding eigen vectors are', eigen_vector); // book values differ since it has multiplied by a common number

// P is a matrix of eigenvectors
// In example 3.4.6 same matrix is there
// The matrix varies as there can be many eigen vectors possible and applying the formula gives this precise value
// P matrix is arranged in this manner so as to match with the book to not confuse the reader. 
// Even if the same order is taken without re-arranging, the answer will be the same.

P=[eigen_vector(:,4) eigen_vector(:,2) eigen_vector(:,1) eigen_vector(:,3)]
disp('P =', P);
P_inv = inv(P);

// calculating diagonal matrix D
D=round(P_inv*A*P);
disp('Diagonal matrix is', D);

A_pow_11 = P*(D^11)*P_inv;
disp('A^11 =', A_pow_11);
